// naumann@stce.rwth-aachen.de

#pragma once

#include<ostream>

template<typename T>
class vector {
protected:
  T* v; size_t n;
public:
  vector(size_t n) : v(new T[n]), n(n) {
    for (size_t i=0;i<n;i++) v[i]=42;
  }
  virtual ~vector() { delete [] v; }
  vector(const vector& x) : v(new T[x.n]), n(x.n) {}
  virtual vector& operator=(const vector& x) {
    if (&x==this) return *this;
    if (n==x.n) 
      for (size_t i=0;i<n;i++) v[i]=x.v[i];
    else {
      delete [] v; n=x.n; v=new T[n]; 
      for (size_t i=0;i<n;i++) v[i]=x.v[i];
    }
    return *this;
  }
  size_t size() const { return n; }
  virtual const T& operator[](size_t i) const { return v[i]; }
  virtual T& operator[](size_t i) { return v[i]; }
};

template<typename T>
std::ostream& operator<<(std::ostream& o, const vector<T>& x) {
  o << "[ ";
  for (size_t i=0;i<x.size();i++) o << x[i] << " ";
  o << "]";
  return o;
}
