// naumann@stce.rwth-aachen.de

#include "vector_hierarchy.hpp"

#include <iostream>
#include <stdexcept>

int main(int argc, char*[]) {
  const int n=3;
  abstract_array<int> *v; 
  switch (argc) {
    case 1: v=new safe_vector<int>(n); break; 
    case 2: v=new unsafe_vector<int>(n); break; 
    case 3: v=new safe_std_vector<int>(n); break; 
    default: v=new unsafe_std_vector<int>(n); 
  }
  try {
    for (int i=0;i<n;i++) (*v)[i]=i;
    std::cout << (*v)[n] << std::endl; 
  } catch (const std::out_of_range &e) { 
    std::cout << "ERROR: " << e.what() << std::endl; 
    return -1; 
  }
  delete v;
  return 0;
}
